Function mouselook(ent) ;   
	mxspd#=MouseXSpeed()*0.25
	myspd#=MouseYSpeed()*0.25

	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2	
	
	campitch#=EntityPitch(ent)+myspd#
	
	If campitch#<-85 Then campitch#=-85 ;  ,         ,    
	If campitch#>85 Then campitch#=85

	RotateEntity ent,campitch#,EntityYaw(ent)-mxspd#,EntityRoll(ent)
End Function

Function WASD(ent)
	Speed# = 0.01*dt
	SY# = Sin(EntityYaw(Ent))
	CY# = Cos(EntityYaw(Ent))
	DebugLog "Sin: "+SY+" Cos: "+CY
	If KeyDown(17) Then
		TranslateEntity ent,Speed*-SY,0,Speed*CY
	End If
	If KeyDown(30) Then
		TranslateEntity ent,Speed*-CY,0,Speed*-SY
	End If
	If KeyDown(31) Then
		TranslateEntity ent,Speed*SY,0,Speed*-CY
	End If
	If KeyDown(32) Then
		TranslateEntity ent,Speed*CY,0,Speed*SY
	End If
End Function

Function LoadSkyBox( file$, rash$ = ".dds" )
	m=CreateMesh()
	;front face
	b=LoadBrush( file$+"_FR"+rash,49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,-1,0,0:AddVertex s,+1,+1,-1,1,0
	AddVertex s,+1,-1,-1,1,1:AddVertex s,-1,-1,-1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3:
	FreeBrush b
	;right face
	b=LoadBrush( file$+"_LF"+rash,49 )
	s=CreateSurface( m,b )
	AddVertex s,+1,+1,-1,0,0:AddVertex s,+1,+1,+1,1,0
	AddVertex s,+1,-1,+1,1,1:AddVertex s,+1,-1,-1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;back face
	b=LoadBrush( file$+"_BK"+rash,49 )
	s=CreateSurface( m,b )
	AddVertex s,+1,+1,+1,0,0:AddVertex s,-1,+1,+1,1,0
	AddVertex s,-1,-1,+1,1,1:AddVertex s,+1,-1,+1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;left face
	b=LoadBrush( file$+"_RT"+rash,49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,+1,0,0:AddVertex s,-1,+1,-1,1,0
	AddVertex s,-1,-1,-1,1,1:AddVertex s,-1,-1,+1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;top face
	b=LoadBrush( file$+"_UP"+rash,49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,+1,0,1:AddVertex s,+1,+1,+1,0,0
	AddVertex s,+1,+1,-1,1,0:AddVertex s,-1,+1,-1,1,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;bottom face	
	b=LoadBrush( file$+"_DN"+rash,49 )
	If b=0 b=CreateBrush (0,30,50)
	s=CreateSurface( m,b )
	AddVertex s,-1,-1,-1,1,0:AddVertex s,+1,-1,-1,1,1
	AddVertex s,+1,-1,+1,0,1:AddVertex s,-1,-1,+1,0,0
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	ScaleMesh m,10000,10000,10000
	FlipMesh m
	EntityFX m,1+8
	Return m
End Function

;     
;: ,  ,    
Function CreateCamQuad(surf%, zoom# = 1.0, near# = 1.0,xShift#=0,yShift#=0)
    Local xscr%, yscr%, xcnt%, ycnt%, xpos#, ypos#, i%[4]
    ; 
    xscr = GraphicsWidth()
    yscr = GraphicsHeight()
    ;  
    xcnt = xscr Shr 1
    ycnt = yscr Shr 1
    ;   
    xpos = (   0 - xcnt) * near / +zoom / xcnt+xShift
    ypos = (   0 - ycnt) * near / -zoom / xcnt+yShift
    i[0] = AddVertex(surf, xpos, ypos, 0.0, 0.0, 0.0)
    ;   
    xpos = (xscr - xcnt) * near / +zoom / xcnt+xShift
    ypos = (   0 - ycnt) * near / -zoom / xcnt+yShift
    i[1] = AddVertex(surf, xpos, ypos, 0.0, 1.0, 0.0)
    ;   
    xpos = (xscr - xcnt) * near / +zoom / xcnt+xShift
    ypos = (yscr - ycnt) * near / -zoom / xcnt+yShift
    i[2] = AddVertex(surf, xpos, ypos, 0.0, 1.0, 1.0)
    ;   
    xpos = (   0 - xcnt) * near / +zoom / xcnt+xShift
    ypos = (yscr - ycnt) * near / -zoom / xcnt+yShift
    i[3] = AddVertex(surf, xpos, ypos, 0.0, 0.0, 1.0)
    AddTriangle(surf, i[0], i[1], i[2])
    AddTriangle(surf, i[2], i[3], i[0])
    Return i[0]
End Function

Global GlowQuality#=.4
Global dt

Local GlowOn = 1

;Graphics3D 800,600,32,2
Graphics3D 1280,1024,32,1
SetBuffer BackBuffer()

ScaleEntity LoadSkyBox( "Day\Sky"),.100,.100,.100
Grass = LoadTexture("grass.dds")
ScaleTexture grass,20,20
EntityTexture CreatePlane(),grass

Tree = LoadMesh("Tree.b3d")
ScaleMesh tree,5,5,5

;For i=0 To 20
;	Single = CreateMesh()
;	For i=0 To 46
;		angle# = Rnd(0,360)
;		distance# = Rnd(25,250)
		
;		x# = Cos(angle)*distance
;		y# = Sin(angle)*distance
		
;		Roll# = Rnd(0,360)
		
;		RotateMesh Tree,0,Roll,0
;		PositionMesh Tree,x,0,y
		
;		AddMesh Tree,Single
		
;		PositionMesh Tree,-x,0,-y
;		RotateMesh Tree,0,-Roll,0		
;	Next
;Next

For i=0 To 200
	angle# = Rnd(0,360)
	distance# = Rnd(0,250)
		
	x# = Cos(angle)*distance
	y# = Sin(angle)*distance
	
	PositionEntity CopyEntity(Tree),x,0,y
	
Next


FreeEntity tree

cam = CreateCamera()
CameraRange cam,0.01,100

Local LOG2Den#=1/Log(2)
TexW=2^Ceil(Log(GraphicsWidth()*GlowQuality)*LOG2Den)
TexH=2^Ceil(Log(GraphicsHeight()*GlowQuality)*LOG2Den)

glowtex = CreateTexture (TexW,TexH,256)
ScaleTexture glowtex,TexW/(GraphicsWidth()*GlowQuality),TexH/(GraphicsHeight()*GlowQuality)

glowtex2 = CreateTexture (TexW,TexH,256)
ScaleTexture glowtex2,TexW/(GraphicsWidth()*GlowQuality),TexH/(GraphicsHeight()*GlowQuality)

glowmesh = CreateMesh(cam)
glowsurf = CreateSurface(glowmesh)
CreateCamQuad(glowsurf)
PositionEntity glowmesh,0,0,1
EntityFX GlowMesh,1
EntityBlend GlowMesh,3

glowmesh2 = CreateMesh(cam)
glowsurf2 = CreateSurface(glowmesh2)
EntityFX GlowMesh2,1

For i=0 To 49
	xShift# = Rnd(-.05,.05)
	yShift# = Rnd(-.05,.05)
	CreateCamQuad(glowsurf2,1,1,xShift,yShift)
Next
PositionEntity glowmesh2,0,0,1

HideEntity glowmesh2

EntityAlpha glowmesh,1
EntityAlpha glowmesh2,0.02

EntityTexture glowmesh,glowtex
EntityTexture glowmesh2,glowtex2

CreateLight()

PositionEntity cam,0,5,0

SetFont(LoadFont("Arial cyr",16))

Repeat

cycletime = MilliSecs()

;TurnEntity cube,1,1,1

If KeyHit(57) Then GlowOn = Not GlowOn
If KeyHit(47) Then VSync = Not VSync

mouselook(cam)
WASD(cam)

If GlowOn Then 
ShowEntity glowmesh
CameraViewport cam,0,0,GraphicsWidth()*GlowQuality,GraphicsHeight()*GlowQuality
HideEntity glowmesh
HideEntity glowmesh2
RenderWorld() ;  
CopyRect 0,0,GraphicsWidth()*GlowQuality,GraphicsHeight()*GlowQuality,0,0, BackBuffer(),TextureBuffer(glowtex2)
ShowEntity glowmesh2
CameraRange cam,.1,1.1
RenderWorld() ;  
CameraRange cam,.1,10000
CopyRect 0,0,GraphicsWidth()*GlowQuality,GraphicsHeight()*GlowQuality,0,0, BackBuffer(),TextureBuffer(glowtex)
ShowEntity glowmesh
HideEntity glowmesh2
CameraViewport cam,0,0,GraphicsWidth(),GraphicsHeight()
Else
HideEntity glowmesh
End If
RenderWorld()
Text 20,20," ( ): "+GlowOn
Text 20,40,"FPS: "+1000.0/dt
Text 20,60, "  ( V): "+VSync
Flip VSync
dt = MilliSecs() - cycletime

Until KeyHit(1)

End 